local L = LibStub("AceLocale-3.0"):GetLocale("MillButton")

--[[ Optionstable ]]
MillButton_DefaultOptions = {
	extended = false,	--fr die Optionale Chatausgabe der bersrpungenen Kruter (entfllt evtl.)
	macro = false,		--flag fr die automatische macro erstellung; das neue macro muss per hand in die aktionsleiste gezogen werden
	macroID = nil,		--falls man sich entscheiden sollte das generierte macro nicht mehr nutzen zu wollen muss es ber die gespeicherte macroID gelscht werden
	ttip = false,		--tooltip in options
};

--[[ Expansiontable ]]
MillButtonExpansions = {
	"Classic",
	"BC",
	"WotLK",
	"Cata",
	"MoP",
	"WoD",
};

MillButtonExpansionLogos = {
	[[Interface\Glues\Common\Glues-WoW-Logo]],
	[[Interface\Glues\Common\GLUES-WOW-BCLOGO]],
	[[Interface\Glues\Common\Glues-WOW-WotlkLogo]],
	[[Interface\Glues\Common\Glues-WOW-CCLogo]],
	[[Interface\Glues\Common\Glues-WOW-MPLogo]],
	[[Interface\Glues\Common\Glues-WOW-WoDLogo]],
}

--[[ NEW Code BEGINN ]]
local ADDON, Addon = ...
local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "MillButton" then
		if MillButtonDB == nil then			
			MillButtonDB = {}
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Default settings loaded")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Settings loaded")		
		end
		if MillButtonSettings == nil then
			MillButtonSettings = MillButton_DefaultOptions
		end
	end
end)

local Options = CreateFrame("Frame", ADDON.."Options", InterfaceOptionsFramePanelContainer)
	Options.name = GetAddOnMetadata(ADDON, "Title") or ADDON
	InterfaceOptions_AddCategory(Options)
	Addon.OptionsPanel = Options

	Options:SetScript("OnShow", function()
		local Title = Options:CreateFontString("$parentTitle", "ARTWORK", "GameFontNormalLarge")
		Title:SetPoint("TOPLEFT", 16, -16)
		Title:SetText(Options.name)
		
		local Notes = Options:CreateFontString("$parentSubText", "ARTWORK", "GameFontHighlightSmall")
		Notes:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8)
		Notes:SetPoint("RIGHT", -32, 0)
		Notes:SetHeight(8)
		Notes:SetJustifyH("LEFT")
		Notes:SetJustifyV("TOP")
		Notes:SetText("Version: "..GetAddOnMetadata(ADDON, "Version"))
			
		local OptionPanel = CreateFrame("Frame", nil, Options)
		OptionPanel:SetPoint("TOPLEFT", Notes, "BOTTOMLEFT", 0, -24)
		OptionPanel:SetPoint("BOTTOMRIGHT", Options, -16, 16)
		OptionPanel:SetBackdrop({
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets= { left = 3, right = 3, top = 5, bottom = 3 }
		})
		OptionPanel:SetBackdropColor(0.1, 0.1, 0.1, 0.5)
		OptionPanel:SetBackdropBorderColor(0.4, 0.4, 0.4)
		
		local myCheckButton = CreateFrame("CheckButton", "myCheckButton_GlobalName", OptionPanel, "ChatConfigCheckButtonTemplate")
		myCheckButton:SetPoint("TOPLEFT", 16, -10)
		myCheckButton_GlobalNameText:SetText("  MillButton extended")
		--myCheckButton.tooltip = "This is where you place MouseOver Text."
		myCheckButton:SetScript("OnClick", 
		function()
			PlaySound("igMainMenuOptionCheckBoxOn" or "igMainmenuOptionCheckBoxOff")
			local isChecked = myCheckButton:GetChecked()
			if isChecked == true then 
				MillButtonSettings.extended = true
				--print(MillButtonSettings.extended)
			else
				MillButtonSettings.extended = false
				--print(MillButtonSettings.extended)
			end			
		end)
		myCheckButton:SetChecked(MillButtonSettings.extended)
		
		local ttip_cb = CreateFrame("CheckButton", "ttip_cb_GlobalName", OptionPanel, "ChatConfigCheckButtonTemplate")
		ttip_cb:SetPoint("TOPLEFT", 16, -40)
		ttip_cb_GlobalNameText:SetText("  Tooltip in options")
		--myCheckButton.tooltip = "This is where you place MouseOver Text."
		ttip_cb:SetScript("OnClick", 
		function()
			PlaySound("igMainMenuOptionCheckBoxOn" or "igMainmenuOptionCheckBoxOff")
			local isChecked = ttip_cb:GetChecked()
			if isChecked == true then 
				MillButtonSettings.ttip = true
				--print(MillButtonSettings.ttip)
			else
				MillButtonSettings.ttip = false
				--print(MillButtonSettings.ttip)
			end			
		end)
		ttip_cb:SetChecked(MillButtonSettings.ttip)
		
		--Let's create the MillButton Macro
		local myButton1 = CreateFrame("Button", "MyButton1", OptionPanel, "UIPanelButtonTemplate")
		myButton1:SetSize(120, 22)
		myButton1:SetText("Create Macro")
		myButton1:SetPoint("TOPLEFT", 16, -70)
		myButton1:SetScript("OnClick", function()
			CreateMacro("MillButtonMacro", "ability_miling", "#showtooltip "..mill_spell.."\n/run MillButtonSetup()\n/click MillButton", 1, 1)
			index = GetMacroIndexByName("MillButtonMacro")	--get macroid
			MillButtonSettings.macroID = index				--and save it
			PickupMacro(index)								--Pickup the new macro for the user to place it on a actionbar
			--DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Macro created")
			MyButton1:Disable()
			MyButton2:Enable()
		end)
		
		--Let's delete the MillButton Macro
		local myButton2 = CreateFrame("Button", "MyButton2", OptionPanel, "UIPanelButtonTemplate")
		myButton2:SetSize(120, 22)
		myButton2:SetText("Delete Macro")
		myButton2:SetPoint("TOPLEFT", 16, -100)
		myButton2:SetScript("OnClick", function()
			--if the macro isn't present i reset the saved id 
			index = GetMacroIndexByName("MillButtonMacro")	--get macroid
			DeleteMacro(index)
			MillButtonSettings.macroID = nil
			--DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r Macro deleted")
			MyButton2:Disable()
			MyButton1:Enable()
		end)

		if MillButtonSettings.macroID ~= nil then
			myButton1:Disable()
			myButton2:Enable()
		else
			myButton1:Enable()
			myButton2:Disable()
		end

		for i = 1, #MillButtonExpansions do
			-- Make a child panel
			local Options_Child = CreateFrame("Frame", ADDON.."Child", Options)
			Options_Child.name = MillButtonExpansions[i]
			Options_Child.id = i+1
			-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
			Options_Child.parent = Options.name
			-- Add the child to the Interface Options
			InterfaceOptions_AddCategory(Options_Child)
			
			local texframe = Options_Child:CreateTexture("Frame", nil, UIParent)
			texframe:SetWidth(240)
			texframe:SetHeight(100)
			texframe:SetPoint("TOPLEFT", 16, -8)
			texframe:SetTexture(MillButtonExpansionLogos[i])
			
			local SubOptionPanel = CreateFrame("Frame", nil, Options_Child)
			SubOptionPanel:SetPoint("TOPLEFT", texframe, "BOTTOMLEFT", 0, 0)
			SubOptionPanel:SetPoint("BOTTOMRIGHT", Options_Child, -16, 16)
			SubOptionPanel:SetBackdrop({
				bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
				edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
				tile = true, tileSize = 16, edgeSize = 16,
				insets= { left = 3, right = 3, top = 5, bottom = 3 }
			})
			SubOptionPanel:SetBackdropColor(0.1, 0.1, 0.1, 0.5)
			SubOptionPanel:SetBackdropBorderColor(0.4, 0.4, 0.4)
			
			Options_Child:SetScript("OnShow",
				function(self)
				PlaySound("igMainMenuOptionCheckBoxOn" or "igMainmenuOptionCheckBoxOff")
				--checkboxes begin
				local expansion = Options_Child.name
			--	print(expansion.." clicked")
				--wenn noch keine checkboxen vorhanden dann erstmal erstellen
				if not self.herbCheckboxes then
					self.herbCheckboxes = {}
					--ankerpunkt fr die erste checkbox
					local tAnchorPointY = -120
					local tAnchorPointX  = 30
					local tAnchorPointCount  = 0
					--alle kruter der jeweiligen untertabelle durchgehen und jeweils eine checkbox erstellen
					for itemID, optionValue in pairs(MillButton_Herblist[expansion]) do
						--name des krauts fr das label der checkbox holen
						local itemName = L[tostring(itemID)]
						--checkbox erstellen (siehe helper function unten) und fr spteren zugriff referenz auf checkbox-objekt mit itemid vom kraut als index in herbCheckboxes speichern
						self.herbCheckboxes[itemID] = Addon:CreateOptionsCheckButton(self, itemName, itemID)
						self.herbCheckboxes[itemID].itemID = itemID
						--passend anordnen
						self.herbCheckboxes[itemID]:SetPoint("TOPLEFT", self, "TOPLEFT", tAnchorPointX, tAnchorPointY)
						--ankerpunkt fr die nchste checkbox
						tAnchorPointY = tAnchorPointY - self.herbCheckboxes[itemID]:GetHeight()
						tAnchorPointCount = tAnchorPointCount + 1
						if tAnchorPointCount > 16 then
							tAnchorPointX = tAnchorPointX + 180
							tAnchorPointY = -120
							tAnchorPointCount = 0
						end 
					end
				end
				--alle inhalte self.herbCheckboxes durchgehen und den aktuellen wert (checked/nicht checked bzw. true/false) fr die checkbox entsprechend der db festlegen
				for itemID, checkboxObj in pairs(self.herbCheckboxes) do
					--wert der checkbox entsprechend der tabelle festlegen
					if MillButtonDB[itemID]==true then
						--print("DB_expansion: "..expansion)
						--print("DB_itemID: "..itemID)
						checkboxObj:SetChecked(MillButtonDB[itemID])
					else
						--print("HL_expansion: "..expansion)
						checkboxObj:SetChecked(MillButton_Herblist[expansion][itemID])
					end
					--bei wertnderung in der db speichern
					checkboxObj:SetScript("OnClick", function(self)
						--print(self:GetParent().name)
						--print(self.itemID)
						MillButtonDB[self.itemID] = self:GetChecked()
					end)
				end
				--checkboxes end
			end)
			
		end
		
		Options:SetScript("OnShow", nil)
			
	end)
	
SLASH_MILLBUTTON1 = "/millbutton"
SLASH_MILLBUTTON2 = "/mbtn"
SlashCmdList.MILLBUTTON = function() InterfaceOptionsFrame_OpenToCategory(Options) end

--[ Checkbox HELPERS Beginn ]
function Addon:CreateOptionsCheckButton(pParentFrame, pLabelText, pLabelID)
	local name = "CBF"..pLabelID
    local tCheckBoxFrame = CreateFrame("CheckButton", name, pParentFrame, "ChatConfigCheckButtonTemplate")
    tCheckBoxFrame:SetWidth(25)
    tCheckBoxFrame:SetHeight(25)
    tCheckBoxFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up")
    tCheckBoxFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down")
    tCheckBoxFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight")
    tCheckBoxFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check")
    tCheckBoxFrame:SetDisabledCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check-Disabled")
    tCheckBoxFrame:SetFrameStrata("HIGH")
	_G[name.."Text"]:SetText("  "..pLabelText)
    tCheckBoxFrame:Show()
	
	--[[local tFS = tCheckBoxFrame:CreateFontString(nil, "ARTWORK")
    tCheckBoxFrame.fontstring = tFS
    --tFS:SetFont("Fonts\\ARIALN.TTF", 12)
    tFS:SetFontObject(GameFontNormal)
	tFS:SetText(pLabelText)
    tFS:SetTextColor(1, 1, 1, 1)
    tFS:SetJustifyH("LEFT")
    tFS:SetJustifyV("TOP")
    tFS:SetPoint("LEFT", tCheckBoxFrame, "RIGHT", 0, 0)
    tFS:Show()]]

	if MillButtonSettings.ttip == true then
		tCheckBoxFrame:SetScript("OnEnter", function(self)
			GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
			GameTooltip:SetItemByID(pLabelID)
			GameTooltip:Show()
		end)
		tCheckBoxFrame:SetScript("OnLeave", function(self)
			GameTooltip:Hide()
		end)
	end
	
    return tCheckBoxFrame
end
--[ Checkbox HELPERS Ende ]
--[[ NEW Code ENDE ]]